#!/usr/bin/env python
# -*- coding: euc-jp -*-

"""
 \file CorbaObjManager.py
 \brief CORBA Object manager class
 \date $Date: 2007/08/27$
 \author Noriaki Ando <n-ando@aist.go.jp> and Shinji Kurihara

 Copyright (C) 2006
     Noriaki Ando
     Task-intelligence Research Group,
     Intelligent Systems Research Institute,
     National Institute of
         Advanced Industrial Science and Technology (AIST), Japan
     All rights reserved.
"""


from omniORB import CORBA, PortableServer

import OpenRTM


class CorbaObjectManager:
	
	"""
	\if jp
	\class CorbaObjectManager
	\brief CORBA ֥Ȥ򥢥ƥֲ󥢥ƥֲ
	\else
	\class CorbaObjectManager
	\brief Activate and deactivate CORBA objects
	\endif
	"""


	def __init__(self, orb, poa):
		"""
		\if jp
		\brief 󥹥ȥ饯
		\else
		\brief Constructor
		\endif
		"""
		self._orb = orb
		self._poa = poa


	def __del__(self):
		"""
		\if jp
		\brief ǥȥ饯
		\elqse
		\brief Destructor
		\endif
		"""
		pass


	def activate(self, comp):
		"""
		\if jp
		\brief CORBA ֥Ȥ򥢥ƥֲ
		\else
		\brief Activate CORBA object
		\endif
		"""
		id_ = self._poa.activate_object(comp)
		obj = self._poa.id_to_reference(id_)
		comp.setObjRef(obj._narrow(OpenRTM.RTObject_impl))


	def deactivate(self, comp):
		"""
		\if jp
		\brief CORBA ֥Ȥ󥢥ƥֲ
		\else
		\brief Deactivate CORBA object
		\endif
		"""
		id_ = self._poa.servant_to_id(comp)
		self._poa.deactivate_object(id_)
